"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.cancelEvent = exports.bulkCancelEvent = exports.bulkReportEvent = exports.reportEvent = exports.ActivationActionStatusChangedStatus = exports.Status = exports.RuntimeStatus = exports.IdentifierType = exports.Language = exports.BlockType = exports.WebhookIdentityType = exports.ScheduleStatus = exports.Units = exports.ActivationStatusChangedStatus = exports.SkipReason = exports.ErrorReason = exports.CancellationReason = exports.Target = exports.Origin = exports.AutomationConfigurationStatus = exports.Type = exports.CodeSnippetLanguage = exports.Operator = exports.TimeUnit = exports.Domain = void 0;
const transform_error_1 = require("@wix/sdk-runtime/transform-error");
const rename_all_nested_keys_1 = require("@wix/sdk-runtime/rename-all-nested-keys");
const ambassadorWixAutomationsV2Activation = __importStar(require("./automations-v2-activation-activations.http.js"));
var Domain;
(function (Domain) {
    /** User domain (default). */
    Domain["USER"] = "USER";
    /** Wix domain. */
    Domain["WIX"] = "WIX";
    /** Wix account-level domain. */
    Domain["WIX_ACCOUNT"] = "WIX_ACCOUNT";
})(Domain || (exports.Domain = Domain = {}));
var TimeUnit;
(function (TimeUnit) {
    TimeUnit["UNKNOWN_TIME_UNIT"] = "UNKNOWN_TIME_UNIT";
    /** Minutes. */
    TimeUnit["MINUTES"] = "MINUTES";
    /** Hours. */
    TimeUnit["HOURS"] = "HOURS";
    /** Days. */
    TimeUnit["DAYS"] = "DAYS";
    /** Weeks. */
    TimeUnit["WEEKS"] = "WEEKS";
    /** Months. */
    TimeUnit["MONTHS"] = "MONTHS";
})(TimeUnit || (exports.TimeUnit = TimeUnit = {}));
var Operator;
(function (Operator) {
    /** Unknown. */
    Operator["UNKNOWN_OPERATOR"] = "UNKNOWN_OPERATOR";
    /** `OR` operator. */
    Operator["OR"] = "OR";
    /** `AND` operator. */
    Operator["AND"] = "AND";
})(Operator || (exports.Operator = Operator = {}));
var CodeSnippetLanguage;
(function (CodeSnippetLanguage) {
    /** Unknown. */
    CodeSnippetLanguage["UNKNOWN_LANGUAGE"] = "UNKNOWN_LANGUAGE";
    /** `JAVASCRIPT` language. */
    CodeSnippetLanguage["JAVASCRIPT"] = "JAVASCRIPT";
})(CodeSnippetLanguage || (exports.CodeSnippetLanguage = CodeSnippetLanguage = {}));
var Type;
(function (Type) {
    /** Based on the trigger. */
    Type["UNKNOWN_ACTION_TYPE"] = "UNKNOWN_ACTION_TYPE";
    /** Defined by a [Wix app](https://dev.wix.com/docs/rest/business-management/automations/automations/automations-v2/about-automation-configuration#app-defined-actions). This action type is available in the site dashboard. */
    Type["APP_DEFINED"] = "APP_DEFINED";
    /** Condition. This determines which action runs next. */
    Type["CONDITION"] = "CONDITION";
    /** Delay. The automation must wait before executing the next step. */
    Type["DELAY"] = "DELAY";
    /** Rate-limiter. This stops the automation flow if the subsequent action has reached its maximum allowed executions. */
    Type["RATE_LIMIT"] = "RATE_LIMIT";
})(Type || (exports.Type = Type = {}));
var AutomationConfigurationStatus;
(function (AutomationConfigurationStatus) {
    /** Unknown. */
    AutomationConfigurationStatus["UNKNOWN_STATUS"] = "UNKNOWN_STATUS";
    /** Active. Active automations can be triggered. */
    AutomationConfigurationStatus["ACTIVE"] = "ACTIVE";
    /** Inactive. Inactive automations cannot be triggered. */
    AutomationConfigurationStatus["INACTIVE"] = "INACTIVE";
})(AutomationConfigurationStatus || (exports.AutomationConfigurationStatus = AutomationConfigurationStatus = {}));
var Origin;
(function (Origin) {
    /** Default value. */
    Origin["UNKNOWN_ORIGIN"] = "UNKNOWN_ORIGIN";
    /** Created by a [Wix user](https://dev.wix.com/docs/build-apps/get-started/overview/glossary#wix-user). */
    Origin["USER"] = "USER";
    /** Created by a [Wix app](https://dev.wix.com/docs/build-apps/get-started/overview/glossary#wix-app) for a particular site. */
    Origin["APPLICATION"] = "APPLICATION";
    /** [Preinstalled automation](https://dev.wix.com/docs/build-apps/develop-your-app/extensions/backend-extensions/automations/pre-installed-automations/about-pre-installed-automations). */
    Origin["PREINSTALLED"] = "PREINSTALLED";
})(Origin || (exports.Origin = Origin = {}));
var Target;
(function (Target) {
    Target["UNKNOWN_TARGET"] = "UNKNOWN_TARGET";
    Target["SCHEDULE"] = "SCHEDULE";
    Target["IMMEDIATE"] = "IMMEDIATE";
})(Target || (exports.Target = Target = {}));
var CancellationReason;
(function (CancellationReason) {
    CancellationReason["UNKNOWN_CANCELLATION_REASON"] = "UNKNOWN_CANCELLATION_REASON";
    /** Indicates that the activation was cancelled directly. */
    CancellationReason["EVENT_CANCELLED"] = "EVENT_CANCELLED";
    /** Indicates that the activation was cancelled because the automation was deactivated. */
    CancellationReason["AUTOMATION_DEACTIVATED"] = "AUTOMATION_DEACTIVATED";
    /** Indicates that the activation was cancelled because the automation was deleted. */
    CancellationReason["AUTOMATION_DELETED"] = "AUTOMATION_DELETED";
    /** Indicates that the activation was cancelled after the automation schedule time was reached. */
    CancellationReason["CANCELLED_BY_REFRESH_PAYLOAD"] = "CANCELLED_BY_REFRESH_PAYLOAD";
    /** Indicates that the activation was cancelled due to a UoU GDPR "Right to be Forgotten" request. */
    CancellationReason["CANCELLED_BY_GDPR_REQUEST"] = "CANCELLED_BY_GDPR_REQUEST";
})(CancellationReason || (exports.CancellationReason = CancellationReason = {}));
var ErrorReason;
(function (ErrorReason) {
    /** Unexpected error reason */
    ErrorReason["UNEXPECTED_ERROR_REASON"] = "UNEXPECTED_ERROR_REASON";
    /** Failed to evaluate the schedule date expression */
    ErrorReason["SCHEDULE_DATE_EVALUATION_FAILED"] = "SCHEDULE_DATE_EVALUATION_FAILED";
})(ErrorReason || (exports.ErrorReason = ErrorReason = {}));
var SkipReason;
(function (SkipReason) {
    SkipReason["UNKNOWN_SKIP_REASON"] = "UNKNOWN_SKIP_REASON";
    /** Activation was skipped because the scheduled execution time had already passed at the time of execution. */
    SkipReason["SCHEDULE_DATE_EXPIRED"] = "SCHEDULE_DATE_EXPIRED";
    /** Activation was skipped because the trigger filters defined in the automation did not match the payload. */
    SkipReason["TRIGGER_FILTERS_NOT_PASSED"] = "TRIGGER_FILTERS_NOT_PASSED";
    /** Activation was skipped because it exceeded the configured rate limit (maximum number of executions allowed in a time period). */
    SkipReason["RATE_LIMIT_EXCEEDED"] = "RATE_LIMIT_EXCEEDED";
    /** Activation was skipped because an event with the same idempotency key was already processed. */
    SkipReason["EVENT_ALREADY_PROCESSED"] = "EVENT_ALREADY_PROCESSED";
})(SkipReason || (exports.SkipReason = SkipReason = {}));
var ActivationStatusChangedStatus;
(function (ActivationStatusChangedStatus) {
    ActivationStatusChangedStatus["UNKNOWN_STATUS"] = "UNKNOWN_STATUS";
    /** Indicates that activation has not started yet and no actions have been executed. */
    ActivationStatusChangedStatus["INITIATED"] = "INITIATED";
    /** Activation is in scheduled status when the automation has a future date or debounce defined and we're in the waiting stage and no actions have been executed. */
    ActivationStatusChangedStatus["SCHEDULED"] = "SCHEDULED";
    /** Indicates the automation activation has started and is currently in progress. */
    ActivationStatusChangedStatus["STARTED"] = "STARTED";
    /** Indicates all the automation actions were handled either by invoking them, skipping them, etc. */
    ActivationStatusChangedStatus["ENDED"] = "ENDED";
    /** Indicates the activation was cancelled. */
    ActivationStatusChangedStatus["CANCELLED"] = "CANCELLED";
    /**
     * Indicates the activation failed to start.
     * Note that failure in the activation of a single action will not result in a failure in activation of the entire automation.
     */
    ActivationStatusChangedStatus["FAILED"] = "FAILED";
    /**
     * Indicates that the automation activation was skipped without executing any actions.
     * Note that an activation will either be skipped immediately or move to INITIATED state.
     */
    ActivationStatusChangedStatus["SKIPPED"] = "SKIPPED";
})(ActivationStatusChangedStatus || (exports.ActivationStatusChangedStatus = ActivationStatusChangedStatus = {}));
var Units;
(function (Units) {
    Units["UNKNOWN"] = "UNKNOWN";
    Units["MINUTES"] = "MINUTES";
    Units["HOURS"] = "HOURS";
    Units["DAYS"] = "DAYS";
})(Units || (exports.Units = Units = {}));
var ScheduleStatus;
(function (ScheduleStatus) {
    ScheduleStatus["UNKNOWN_SCHEDULE_STATUS"] = "UNKNOWN_SCHEDULE_STATUS";
    ScheduleStatus["PENDING"] = "PENDING";
    ScheduleStatus["CANCELLED"] = "CANCELLED";
    ScheduleStatus["DONE"] = "DONE";
})(ScheduleStatus || (exports.ScheduleStatus = ScheduleStatus = {}));
var WebhookIdentityType;
(function (WebhookIdentityType) {
    WebhookIdentityType["UNKNOWN"] = "UNKNOWN";
    WebhookIdentityType["ANONYMOUS_VISITOR"] = "ANONYMOUS_VISITOR";
    WebhookIdentityType["MEMBER"] = "MEMBER";
    WebhookIdentityType["WIX_USER"] = "WIX_USER";
    WebhookIdentityType["APP"] = "APP";
})(WebhookIdentityType || (exports.WebhookIdentityType = WebhookIdentityType = {}));
var BlockType;
(function (BlockType) {
    BlockType["UNKNOWN"] = "UNKNOWN";
    BlockType["OR"] = "OR";
    BlockType["AND"] = "AND";
})(BlockType || (exports.BlockType = BlockType = {}));
var Language;
(function (Language) {
    /** Unknown. */
    Language["UNKNOWN_LANGUAGE"] = "UNKNOWN_LANGUAGE";
    /** `JAVASCRIPT` language. */
    Language["JAVASCRIPT"] = "JAVASCRIPT";
})(Language || (exports.Language = Language = {}));
var IdentifierType;
(function (IdentifierType) {
    IdentifierType["UNKNOWN_IDENTIFIER"] = "UNKNOWN_IDENTIFIER";
    IdentifierType["PREINSTALLED"] = "PREINSTALLED";
    IdentifierType["AUTOMATION"] = "AUTOMATION";
})(IdentifierType || (exports.IdentifierType = IdentifierType = {}));
var RuntimeStatus;
(function (RuntimeStatus) {
    RuntimeStatus["UNKNOWN_STATUS"] = "UNKNOWN_STATUS";
    RuntimeStatus["STARTED"] = "STARTED";
    RuntimeStatus["ENDED"] = "ENDED";
    RuntimeStatus["ERROR"] = "ERROR";
    RuntimeStatus["SCHEDULED"] = "SCHEDULED";
    RuntimeStatus["FROM_SCHEDULER"] = "FROM_SCHEDULER";
    RuntimeStatus["RETRY"] = "RETRY";
    RuntimeStatus["RESUMED"] = "RESUMED";
    RuntimeStatus["PAUSED"] = "PAUSED";
    RuntimeStatus["ACTION_SKIPPED"] = "ACTION_SKIPPED";
})(RuntimeStatus || (exports.RuntimeStatus = RuntimeStatus = {}));
var Status;
(function (Status) {
    /** Unknown action completion status. */
    Status["UNKNOWN_STATUS"] = "UNKNOWN_STATUS";
    /** Action completed successfully. */
    Status["SUCCESS"] = "SUCCESS";
    /** Action failed to complete. */
    Status["FAILURE"] = "FAILURE";
})(Status || (exports.Status = Status = {}));
var ActivationActionStatusChangedStatus;
(function (ActivationActionStatusChangedStatus) {
    ActivationActionStatusChangedStatus["UNKNOWN_ACTION_ACTIVATION_STATUS"] = "UNKNOWN_ACTION_ACTIVATION_STATUS";
    /**
     * Indicates that action activation has started and is in progress.
     * Relevant to action types: APP_DEFINED, DELAY.
     */
    ActivationActionStatusChangedStatus["STARTED"] = "STARTED";
    /** Indicates that async action was invoked and now waiting to be completed */
    ActivationActionStatusChangedStatus["INVOKED_ASYNC"] = "INVOKED_ASYNC";
    /**
     * Indicates that the action activation was completed without errors.
     * Relevant to action types: APP_DEFINED, DELAY, CONDITION, RATE_LIMIT.
     */
    ActivationActionStatusChangedStatus["ENDED"] = "ENDED";
    /**
     * Indicates that the action was skipped and post actions won't start.
     * Relevant to action types: APP_DEFINED.
     */
    ActivationActionStatusChangedStatus["SKIPPED"] = "SKIPPED";
    /**
     * Indicates that the action failed.
     * Relevant to action types: APP_DEFINED, DELAY, RATE_LIMIT.
     */
    ActivationActionStatusChangedStatus["FAILED"] = "FAILED";
})(ActivationActionStatusChangedStatus || (exports.ActivationActionStatusChangedStatus = ActivationActionStatusChangedStatus = {}));
/**
 * Reports an event and activates site automations with the specified trigger key.
 *
 *
 * Only the app that created a trigger can report events for it.
 * This means other apps can't report events for your triggers,
 * and you can't report events for another app's triggers.
 *
 * If your app supports canceling events,
 * `externalEntityId` must be provided.
 * `externalEntityId` is required when calling [cancelEvent()](#cancel-event).
 * @param triggerKey - Trigger key as defined in your app's trigger configuration
 * in the app dashboard.
 * For example, `form_submitted` or `invoice_due`.
 * @public
 * @requiredField triggerKey
 * @permissionId AUTOMATIONS.REPORT_EVENT
 * @permissionScope Manage Stores
 * @permissionScopeId SCOPE.STORES.MANAGE-STORES
 * @permissionScope Manage Your App
 * @permissionScopeId SCOPE.DC.MANAGE-YOUR-APP
 * @permissionScope Read site, business, and email details
 * @permissionScopeId SCOPE.DEV_CENTER.APP-INSTANCE-READ-BASIC-INFO
 * @permissionScope Set Up Automations
 * @permissionScopeId SCOPE.CRM.SETUP-AUTOMATIONS
 * @applicableIdentity APP
 * @fqn wix.automations.esb.resolver.v1.EsbConfigResolver.ReportEvent
 */
async function reportEvent(triggerKey, options) {
    // @ts-ignore
    const { httpClient, sideEffects } = arguments[2];
    const payload = (0, rename_all_nested_keys_1.renameKeysFromSDKRequestToRESTRequest)({
        triggerKey: triggerKey,
        payload: options?.payload,
        externalEntityId: options?.externalEntityId,
        idempotency: options?.idempotency,
    });
    const reqOpts = ambassadorWixAutomationsV2Activation.reportEvent(payload);
    sideEffects?.onSiteCall?.();
    try {
        const result = await httpClient.request(reqOpts);
        sideEffects?.onSuccess?.(result);
        return (0, rename_all_nested_keys_1.renameKeysFromRESTResponseToSDKResponse)(result.data);
    }
    catch (err) {
        const transformedError = (0, transform_error_1.transformError)(err, {
            spreadPathsToArguments: {},
            explicitPathsToArguments: {
                triggerKey: '$[0]',
                payload: '$[1].payload',
                externalEntityId: '$[1].externalEntityId',
                idempotency: '$[1].idempotency',
            },
            singleArgumentUnchanged: false,
        }, ['triggerKey', 'options']);
        sideEffects?.onError?.(err);
        throw transformedError;
    }
}
exports.reportEvent = reportEvent;
/**
 * Bulk reports events and activates site automations with the specified trigger key.
 * @param triggerKey - Trigger key as defined in your app's trigger configuration
 * in the app dashboard.
 * For example, `form_submitted` or `invoice_due`.
 * @param eventsInfo - Repeated list of event details for bulk reporting.
 * @public
 * @requiredField eventsInfo
 * @requiredField triggerKey
 * @permissionId AUTOMATIONS.REPORT_EVENT
 * @permissionScope Manage Stores
 * @permissionScopeId SCOPE.STORES.MANAGE-STORES
 * @permissionScope Manage Your App
 * @permissionScopeId SCOPE.DC.MANAGE-YOUR-APP
 * @permissionScope Read site, business, and email details
 * @permissionScopeId SCOPE.DEV_CENTER.APP-INSTANCE-READ-BASIC-INFO
 * @permissionScope Set Up Automations
 * @permissionScopeId SCOPE.CRM.SETUP-AUTOMATIONS
 * @applicableIdentity APP
 * @fqn wix.automations.esb.resolver.v1.EsbConfigResolver.BulkReportEvent
 */
async function bulkReportEvent(triggerKey, eventsInfo) {
    // @ts-ignore
    const { httpClient, sideEffects } = arguments[2];
    const payload = (0, rename_all_nested_keys_1.renameKeysFromSDKRequestToRESTRequest)({
        triggerKey: triggerKey,
        eventsInfo: eventsInfo,
    });
    const reqOpts = ambassadorWixAutomationsV2Activation.bulkReportEvent(payload);
    sideEffects?.onSiteCall?.();
    try {
        const result = await httpClient.request(reqOpts);
        sideEffects?.onSuccess?.(result);
        return (0, rename_all_nested_keys_1.renameKeysFromRESTResponseToSDKResponse)(result.data);
    }
    catch (err) {
        const transformedError = (0, transform_error_1.transformError)(err, {
            spreadPathsToArguments: {},
            explicitPathsToArguments: { triggerKey: '$[0]', eventsInfo: '$[1]' },
            singleArgumentUnchanged: false,
        }, ['triggerKey', 'eventsInfo']);
        sideEffects?.onError?.(err);
        throw transformedError;
    }
}
exports.bulkReportEvent = bulkReportEvent;
/**
 * Bulk cancels any remaining actions for a trigger and external entities.
 * @param triggerKey - Trigger key whose events you want to cancel.
 * For example, `form_submitted` or `invoice_due`.
 * @param externalEntityIds - Repeated list of external_entity_id, representing the related resources' IDs.
 * @public
 * @requiredField externalEntityIds
 * @requiredField triggerKey
 * @permissionId AUTOMATIONS.CANCEL_EVENT
 * @permissionScope Manage Your App
 * @permissionScopeId SCOPE.DC.MANAGE-YOUR-APP
 * @permissionScope Read site, business, and email details
 * @permissionScopeId SCOPE.DEV_CENTER.APP-INSTANCE-READ-BASIC-INFO
 * @applicableIdentity APP
 * @fqn wix.automations.esb.resolver.v1.EsbConfigResolver.BulkCancelEvent
 */
async function bulkCancelEvent(triggerKey, externalEntityIds) {
    // @ts-ignore
    const { httpClient, sideEffects } = arguments[2];
    const payload = (0, rename_all_nested_keys_1.renameKeysFromSDKRequestToRESTRequest)({
        triggerKey: triggerKey,
        externalEntityIds: externalEntityIds,
    });
    const reqOpts = ambassadorWixAutomationsV2Activation.bulkCancelEvent(payload);
    sideEffects?.onSiteCall?.();
    try {
        const result = await httpClient.request(reqOpts);
        sideEffects?.onSuccess?.(result);
        return (0, rename_all_nested_keys_1.renameKeysFromRESTResponseToSDKResponse)(result.data);
    }
    catch (err) {
        const transformedError = (0, transform_error_1.transformError)(err, {
            spreadPathsToArguments: {},
            explicitPathsToArguments: {
                triggerKey: '$[0]',
                externalEntityIds: '$[1]',
            },
            singleArgumentUnchanged: false,
        }, ['triggerKey', 'externalEntityIds']);
        sideEffects?.onError?.(err);
        throw transformedError;
    }
}
exports.bulkCancelEvent = bulkCancelEvent;
/**
 * Cancels any remaining actions for a trigger and external entity.
 *
 *
 * Events are not cancelable by default.
 * To make an event cancelable,
 * you must first pass an `externalEntityId`
 * and the applicable `triggerKey` to [reportEvent()](#report-event).
 * When you call cancelEvent() with the same `externalEntityId` and `triggerKey`,
 * the event is canceled,
 * as are all other events that share the `externalEntityId` and `triggerKey`.
 * @param triggerKey - Trigger key whose event you want to cancel.
 * For example, `form_submitted` or `invoice_due`.
 * @param externalEntityId - ID of the related resource in GUID format.
 * For example, `fc81a355-3429-50fc-a4c7-def486e828f3`.
 *
 * Typically, this ID is defined in your system,
 * but you can also use any Wix resource GUID,
 * such as contact ID, member ID, or invoice ID.
 * See
 * [Choose the right `externalEntityId`](https://dev.wix.com/docs/rest/business-management/automations/triggered-events/reporting-and-canceling-events#choose-the-right-externalentityid)
 * for more information.
 * @public
 * @requiredField externalEntityId
 * @requiredField triggerKey
 * @permissionId AUTOMATIONS.CANCEL_EVENT
 * @permissionScope Manage Your App
 * @permissionScopeId SCOPE.DC.MANAGE-YOUR-APP
 * @permissionScope Read site, business, and email details
 * @permissionScopeId SCOPE.DEV_CENTER.APP-INSTANCE-READ-BASIC-INFO
 * @applicableIdentity APP
 * @fqn wix.automations.esb.resolver.v1.EsbConfigResolver.CancelEvent
 */
async function cancelEvent(triggerKey, externalEntityId) {
    // @ts-ignore
    const { httpClient, sideEffects } = arguments[2];
    const payload = (0, rename_all_nested_keys_1.renameKeysFromSDKRequestToRESTRequest)({
        triggerKey: triggerKey,
        externalEntityId: externalEntityId,
    });
    const reqOpts = ambassadorWixAutomationsV2Activation.cancelEvent(payload);
    sideEffects?.onSiteCall?.();
    try {
        const result = await httpClient.request(reqOpts);
        sideEffects?.onSuccess?.(result);
    }
    catch (err) {
        const transformedError = (0, transform_error_1.transformError)(err, {
            spreadPathsToArguments: {},
            explicitPathsToArguments: {
                triggerKey: '$[0]',
                externalEntityId: '$[1]',
            },
            singleArgumentUnchanged: false,
        }, ['triggerKey', 'externalEntityId']);
        sideEffects?.onError?.(err);
        throw transformedError;
    }
}
exports.cancelEvent = cancelEvent;
//# sourceMappingURL=automations-v2-activation-activations.universal.js.map