import { reportEvent as publicReportEvent, bulkReportEvent as publicBulkReportEvent, bulkCancelEvent as publicBulkCancelEvent, cancelEvent as publicCancelEvent } from './automations-v2-activation-activations.public.js';
import { BuildRESTFunction, MaybeContext } from '@wix/sdk-types';
export declare const reportEvent: MaybeContext<BuildRESTFunction<typeof publicReportEvent> & typeof publicReportEvent>;
export declare const bulkReportEvent: MaybeContext<BuildRESTFunction<typeof publicBulkReportEvent> & typeof publicBulkReportEvent>;
export declare const bulkCancelEvent: MaybeContext<BuildRESTFunction<typeof publicBulkCancelEvent> & typeof publicBulkCancelEvent>;
export declare const cancelEvent: MaybeContext<BuildRESTFunction<typeof publicCancelEvent> & typeof publicCancelEvent>;
export { Domain, TimeUnit, Operator, CodeSnippetLanguage, Type, AutomationConfigurationStatus, Origin, Target, CancellationReason, ErrorReason, SkipReason, ActivationStatusChangedStatus, Units, ScheduleStatus, WebhookIdentityType, BlockType, Language, IdentifierType, RuntimeStatus, Status, ActivationActionStatusChangedStatus, } from './automations-v2-activation-activations.universal.js';
export { Activation, Automation, AutomationOriginInfoOneOf, ActionSettings, Enrichment, AuditInfo, AuditInfoIdOneOf, AutomationConfiguration, Filter, FutureDateActivationOffset, RateLimit, FilterValueSelection, ConditionExpressionGroup, ActionCodeSnippet, Path, AppDefinedAction, ConditionAction, CodeConditionAction, DelayAction, RateLimitAction, SetVariablesAction, OutputAction, SplitAction, Trigger, AutomationConfigurationAction, AutomationConfigurationActionInfoOneOf, FilterableAppDefinedActions, ApplicationOrigin, PreinstalledOrigin, AutomationSettings, DraftInfo, Enrichments, ExtendedFields, ActivationStatusChanged, ActivationStatusChangedStatusInfoOneOf, Identity, Metadata, InitiatedStatusInfo, ActivationStatusChangedStartedStatusInfo, ScheduledStatusInfo, CancelledStatusInfo, ActivationStatusChangedFailedStatusInfo, SkippedStatusInfo, ScheduleRequest, Schedule, ScheduledAction, Delay, DelayOfOneOf, SimpleDelay, TriggerInfo, ScheduleResponse, CancelPendingScheduleRequest, CancelPendingScheduleRequestByOneOf, CancelPendingScheduleResponse, UpdatePendingSchedulesPayloadRequest, UpdatePendingSchedulesPayloadResponse, DomainEvent, DomainEventBodyOneOf, EntityCreatedEvent, RestoreInfo, EntityUpdatedEvent, EntityDeletedEvent, ActionEvent, MessageEnvelope, IdentificationData, IdentificationDataIdOneOf, ConsumeReportEventRequest, EventInfo, Idempotency, BatchActivationRequest, ActivationRequest, Runtime, Scheduler, AsyncAction, ActionData, Action, ActionActionOneOf, ServiceMapping, IfFilter, SwitchFilter, Case, DelayHelper, RateLimiting, ConditionFilter, ConditionBlock, CodeConditionFilter, CodeSnippet, Output, SetVariables, Service, SystemHelper, SystemHelperHelperOneOf, SpiAction, ActivationSource, ActivationSourceOfOneOf, ActionsData, ActivationScheduleRequested, ScheduleActivationRequested, ActivationContinuedAfterSchedule, ReportEventRequest, ReportEventResponse, BulkReportEventRequest, BulkReportEventResponse, BulkReportEventResult, ItemMetadata, ApplicationError, BulkActionMetadata, BulkCancelEventRequest, BulkCancelEventResponse, BulkCancelEventResult, CancelEventRequest, CancelEventResponse, V1RunAutomationRequest, V1RunAutomationRequestIdentifierOneOf, PreinstalledIdentifier, AutomationIdentifier, V1RunAutomationResponse, ReportDomainEventRequest, ReportDomainEventResponse, ExecuteFromActionRequest, ExecuteFromActionResponse, Empty, ActivationScheduleCompleted, ActionRetryRequest, ActivationContext, ResumeAfterAsyncActionCompleted, ResumeAfterAsyncActionCompletedStatusInfoOneOf, SuccessInfo, FailureInfo, ActivationActionStatusChanged, ActivationActionStatusChangedInfoOneOf, ActivationActionStatusChangedStatusInfoOneOf, RetryInfo, StartedStatusInfoAppDefinedActionInfo, StartedStatusInfoDelayActionInfo, InvokedAsyncStatusInfoAppDefinedActionInfo, ExpressionEvaluationResult, EndedStatusInfoAppDefinedActionInfo, ConditionActionInfo, CodeConditionActionInfo, RateLimitActionInfo, DelayActionInfo, SetVariablesActionInfo, AutomationInfo, AutomationInfoOriginInfoOneOf, AutomationInfoTriggerInfo, ActionAttributes, AppDefinedActionInfo, StartedStatusInfo, StartedStatusInfoTypeInfoOneOf, InvokedAsyncStatusInfo, InvokedAsyncStatusInfoTypeInfoOneOf, EndedStatusInfo, EndedStatusInfoTypeInfoOneOf, FailedStatusInfo, ActivationResumeAfterDelay, ActionCompletedRequest, RefreshPayloadRequest, RefreshPayloadResponse, RunAutomationRequest, RunAutomationResponse, ReportActionInvocationCompletedRequest, ReportActionInvocationCompletedRequestStatusInfoOneOf, ReportActionInvocationCompletedResponse, ReportEventOptions, } from './automations-v2-activation-activations.universal.js';
